'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../src/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // external dependencies


// utils


var IS_PRODUCTION = process.env.NODE_ENV === 'production';

var activeInstancesCount = 0;

/**
 * decorator which receives the generated styles and adds / removes the style tag
 * with the values, and then passing the selectors down as props
 *
 * @param {string} css
 * @param {string} id
 * @param {Object} selectors
 * @returns {function(Component): Component}
 */
var injectCss = function injectCss() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$css = _ref.css,
      css = _ref$css === undefined ? '' : _ref$css,
      id = _ref.id,
      _ref$selectors = _ref.selectors,
      selectors = _ref$selectors === undefined ? {} : _ref$selectors;

  if (!id && !IS_PRODUCTION) {
    throw new TypeError('You have not passed an ID for the style tag to inject. Have you created the object ' + 'correctly with transformStyles?');
  }

  return function (PassedComponent) {
    var StylizedComponent = function (_Component) {
      _inherits(StylizedComponent, _Component);

      function StylizedComponent() {
        var _ref2;

        _classCallCheck(this, StylizedComponent);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        var _this = _possibleConstructorReturn(this, (_ref2 = StylizedComponent.__proto__ || Object.getPrototypeOf(StylizedComponent)).call.apply(_ref2, [this].concat(args)));

        var existingTag = document.getElementById(id);

        if (!existingTag) {
          (0, _utils.injectStyleTag)(id, css);
        }

        activeInstancesCount++;
        return _this;
      }

      _createClass(StylizedComponent, [{
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          activeInstancesCount--;

          if (activeInstancesCount === 0) {
            var existingTag = document.getElementById(id);

            existingTag.parentNode.removeChild(existingTag);
          }
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2.default.createElement(PassedComponent, _extends({}, this.props, {
            selectors: selectors
          }));
        }
      }]);

      return StylizedComponent;
    }(_react.Component);

    return StylizedComponent;
  };
};

exports.default = injectCss;
module.exports = exports['default'];